Re: [PATCH] btrfs: add a test for umount racing mount

[Date Prev] [Date Next] [Thread Prev] [Thread Next] [Date Index] [Thread Index]



On 7/9/20 8:55 PM, Boris Burkov wrote:
Test if dirtying many inodes, which delays the umount in `evict_inodes`,
then umounting and quickly mounting again causes the mount to fail.

This race is fixed by the patch:
"btrfs: fix mount failure caused by race with umount"

Signed-off-by: Boris Burkov <boris@xxxxxx>
---
  tests/btrfs/215     | 52 +++++++++++++++++++++++++++++++++++++++++++++
  tests/btrfs/215.out |  2 ++
  tests/btrfs/group   |  1 +
  3 files changed, 55 insertions(+)
  create mode 100755 tests/btrfs/215
  create mode 100644 tests/btrfs/215.out

diff --git a/tests/btrfs/215 b/tests/btrfs/215
new file mode 100755
index 00000000..b142c2d6
--- /dev/null
+++ b/tests/btrfs/215
@@ -0,0 +1,52 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 YOUR NAME HERE.  All Rights Reserved.

Facebook should go in "YOUR NAME HERE".

+#
+# FS QA Test 215
+#
+# Evicting dirty inodes can take a long time during umount.
+# Check that a new mount racing with such a delayed umount succeeds.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs generic

This isn't btrfs specific, so I'd put it in tests/generic/<whatever>

+_supported_os Linux
+_require_test
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount
+for i in $(seq 0 500)
+	do
+		  dd if=/dev/zero of="$SCRATCH_MNT/$i" bs=1M count=1 > /dev/null 2>&1
+		  done
+		  _scratch_unmount&
+		  _scratch_mount
+

Looks like your tabbing got carried away here, and add a space between _scratch_unmount and the &.

+echo "Silence is golden"
+
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/215.out b/tests/btrfs/215.out
new file mode 100644
index 00000000..0a11773b
--- /dev/null
+++ b/tests/btrfs/215.out
@@ -0,0 +1,2 @@
+QA output created by 215
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 505665b5..dda0763e 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -217,3 +217,4 @@
  212 auto balance dangerous
  213 auto balance dangerous
  214 auto quick send snapshot
+215 auto quick

Spacing appears to be off here too.  Thanks,

Josef



[Index of Archives]     [Linux Filesystems Development]     [Linux NFS]     [Linux NILFS]     [Linux USB Devel]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux